IFNDEF _CQueue_
_CQueue_ equ 1

; --=====================================================================================--
; #CLASS:    CQueue 
; #VERSION:  1.0
; --=====================================================================================--
; Built by NaN's Object Class Creator
;  Sept 19, 2001
;
; By NaN ( jaymeson@hotmail.com )
; http://nan32asm.cjb.net
;
; --=====================================================================================--
; #AUTHOR: Smallwaves
; #DATE:   Feb. 4, 2002
;
; #DESCRIPTION:	  
;
;          This class demostrate how to realize synchronization using mutex and semaphore.You can modify it  to fit your use easily I think..
;
; --=====================================================================================--
; CLASS METHOD PROTOS
; --=====================================================================================--
   CQueue_Init    PROTO  :DWORD ,:DWORD	
; --=====================================================================================--
; FUNCTION POINTER PROTOS
; --=====================================================================================--
   CQue_destructorPto    TYPEDEF  PROTO  :DWORD 
   CQue_AppendPto    TYPEDEF  PROTO  :DWORD, :DWORD, :DWORD
   CQue_RemovePto    TYPEDEF  PROTO  :DWORD, :DWORD, :DWORD

; --=====================================================================================--
; #METHOD:      CQueue_ELEMENT (STRUCT)
;
; #DESCRIPTION: The public CQueue_ELEMENT structure  defines what a queue data element looks like. A real-life application would generally not require this information..
;
; #PARAM:       m_nThreadNum  A member of this structure..
; #PARAM:       m_nRequestNum  A member of this structure..
; --=====================================================================================--
;Declaration of ELEMENT Structure.
	CQueue_ELEMENT struct 
		m_nThreadNum dword ?
		m_nRequestNum dword ?
		;Other element data should go here
   CQueue_ELEMENT ENDS
   PCQueue_ELEMENT typedef ptr CQueue_ELEMENT;not a good solution in a    word, but not forget that this a PreRelease Object.inc!

; --=====================================================================================--
; CLASS STRUCTURE
; --=====================================================================================--
   CLASS CQueue, CQue
      CMETHOD destructor    ; MUST BE THE FIRST, OR OBJECTS.INC WILL FAIL
      CMETHOD Append    
      CMETHOD Remove          
      m_nMaxElements     dd    ?;Maximum # of elements in the array
      m_pElements     PCQueue_ELEMENT    ?;Array of elements to be processed
	  union
      	m_h		dd 2 dup (?);Mutex & semaphore handles
      	struct 
      		m_hmtxQ		dd ?;Reference to m_h[0]
      		m_hsemNumElements  dd ? ;Reference to m_h[1]
      	ends
      ends
      m_hNum	dd ?;number of m_h,here is 2.
   CQueue ENDS

.data
	  
   BEGIN_INIT 
      dd offset CQue_destructor_Funct
      dd offset CQue_Append_Funct
      dd offset CQue_Remove_Funct      
      dd 0
      PCQueue_ELEMENT NULL
      dd 0,0 
      dd 2
   END_INIT
	
.code
; --=====================================================================================--
; #METHOD:      CONSTRUCTOR (:DWORD)
;
; #DESCRIPTION: Initialize mutex and semaphore, and allocate memory for CQueue_ELEMENT array..
;
; #PARAM:       nMaxElements  Max number of CQueue_ELEMENT array..
;
; #RETURN:      Nothing..
; --=====================================================================================--
CQueue_Init  PROC uses edi esi lpTHIS:DWORD,nMaxElements:DWORD
   SET_CLASS CQueue
   SetObject edi, CQueue   
   
   mov eax,sizeof CQueue_ELEMENT
   mov ecx,nMaxElements
   mul 	ecx
   mov esi,eax
   invoke GetProcessHeap
   invoke HeapAlloc,eax,0,esi
   mov [edi].m_pElements,eax
   
   push  nMaxElements
   pop [edi].m_nMaxElements
   
   invoke CreateMutex,NULL, FALSE, NULL
   mov [edi].m_hmtxQ,eax
   invoke CreateSemaphore,NULL, 0, nMaxElements, NULL
   mov [edi].m_hsemNumElements,eax
   	   
   ReleaseObject edi
   ret
CQueue_Init ENDP

; --=====================================================================================--
; #METHOD:      destructor (NONE)
;
; #DESCRIPTION: Do some clean work.Close mutex and semaphore,free memory for CQueue_ELEMENT array..
;
; #RETURN:      Nothing..
; --=====================================================================================--
CQue_destructor_Funct  PROC uses edi lpTHIS:DWORD 
   SetObject edi, CQueue

   invoke CloseHandle,[edi].m_hsemNumElements
   invoke CloseHandle,[edi].m_hmtxQ
   invoke GetProcessHeap
   invoke HeapFree,eax,0, [edi].m_pElements

   ReleaseObject edi
   ret
CQue_destructor_Funct  ENDP

; --=====================================================================================--
; #METHOD:      Append (:DWORD, :DWORD)
;
; #DESCRIPTION: Append new element to the queue..
;
; #PARAM:       pElement   Pointer of the new CQueue_ELEMENT..
; #PARAM:       dwTimeout  Timeouts for waiting for appending..
;
; #RETURN:      FALSE if failed,Call GetLastError for more info..
; --=====================================================================================--
CQue_Append_Funct  PROC uses esi edi lpTHIS:DWORD, pElement:PCQueue_ELEMENT, dwTimeout:DWORD
local fOk:dword,	dw1:dword,	lPrevCount:dword
   SetObject edi, CQueue

	mov fOk,FALSE   
	invoke  WaitForSingleObject,[edi].m_hmtxQ, dwTimeout	   
	
	.if eax == WAIT_OBJECT_0
		;This thread has exclusive access to the queue
		
		;Increment the number of elements in the queue
		invoke ReleaseSemaphore,[edi].m_hsemNumElements, 1,addr lPrevCount
		mov fOk,eax		
		.if eax
			;The queue is not full, append the new element
			mov ecx,sizeof CQueue_ELEMENT
			mov eax,lPrevCount
			mul ecx
			mov esi,[edi].m_pElements
			add esi,eax
			invoke MemCopy,pElement,esi,sizeof CQueue_ELEMENT

		.else
			;The queue is full, set the error code and return failure
			invoke SetLastError, ERROR_DATABASE_FULL
		.endif
		
		;Allow other threads to access the queue
		invoke ReleaseMutex,[edi].m_hmtxQ
	
	.else
		;Timeout, set error code and return failure
		invoke SetLastError,ERROR_TIMEOUT
	.endif
	mov eax,fOk	; Call GetLastError for more info
   
   ReleaseObject edi
   ret
CQue_Append_Funct  ENDP

; --=====================================================================================--
; #METHOD:      Remove (:DWORD, :DWORD)
;
; #DESCRIPTION: Remove a ELEMENT from the queen..
;
; #PARAM:       pElement  if have,the pointer of a CQueue_ELEMENT that has been removed..
; #PARAM:       dwTimeout  Timeouts for waiting for removing..
;
; #RETURN:      FALSE if failed,Call GetLastError for more info..
; --=====================================================================================--
CQue_Remove_Funct  PROC uses esi edi lpTHIS:DWORD, pElement:PCQueue_ELEMENT, dwTimeout:DWORD
local fOk:dword
   SetObject edi, CQueue

	;Wait for exclusive access to queue and for queue to have element.
	invoke WaitForMultipleObjects,[edi].m_hNum,addr [edi].m_h, TRUE, dwTimeout   
	
	.if eax == WAIT_OBJECT_0
		mov eax,TRUE
	.else
		xor eax,eax
	.endif
	mov fOk,eax
	
	.if eax
		;The queu has an element, pull it from the queue
		invoke MemCopy,[edi].m_pElements,pElement,sizeof CQueue_ELEMENT
		
		;Shift the remaining elements down
		mov eax,sizeof CQueue_ELEMENT
		mov ecx,dword ptr [edi].m_nMaxElements
		dec ecx
		mul ecx
		mov ecx,eax							
		push edi
		mov edi,[edi].m_pElements
		mov esi,edi
		add esi,sizeof CQueue_ELEMENT
		rep movsb		
		pop edi
		;invoke RtlMoveMemory, [edi].m_pElements, [edi].m_pElements[sizeof CQueue_ELEMENT],eax

         ;Allow other threads to access the queue
         invoke ReleaseMutex,[edi].m_hmtxQ
         
   .else 
		;Timeout, set error code and return failure  
		invoke SetLastError, ERROR_TIMEOUT
	.endif 
	
	mov eax,fOk; Call GetLastError for more info
   
   ReleaseObject edi
   ret
CQue_Remove_Funct  ENDP

ENDIF
