include Queue.inc
include ..\CmnHdr.inc
include ..\Objects.inc
include CQueue.asm
;**********************CODE SEGMENT*********************************
.code 
start:;START PROG HERE. 
		invoke	GetModuleHandle,NULL
		mov	hInstance,eax		

		NEWOBJECT CQueue,10
		mov g_q,eax		
		
		invoke	InitCommonControls
		invoke	DialogBoxParam,hInstance,IDD_QUEUE,NULL,offset DlgProc,0
		INVOKE InterlockedExchange,addr g_fShutdown, TRUE
		
		;Wait for all the threads to terminate & then cleanup
		invoke WaitForMultipleObjects,g_nNumThreads,addr g_hThreads, TRUE, INFINITE
		push edi
		mov edi,g_nNumThreads
		.while edi
			dec edi 
			invoke CloseHandle,g_hThreads[edi*4]
		.endw
		pop edi
				
		invoke	ExitProcess,NULL
;***********Client Thread Func***********************************
ClientThread proc uses esi, nThreadNum:dword
local hwndLB:dword	,	sz[1024]:byte,	e:CQueue_ELEMENT
	
	invoke GetDlgItem,g_hwnd, IDC_CLIENTS
	mov hwndLB,eax
	mov esi,1;esi == nRequestSum
	.while !g_fShutdown
		push nThreadNum 
		pop e.m_nThreadNum
		mov e.m_nRequestNum, esi
	
		;Try to put an element on the queue		
		method g_q,CQueue,Append,addr e,200
		.if eax
			; Indicate which thread sent it and which request
			invoke wsprintf,addr sz, SADD("Sending %d:%d"), nThreadNum,esi			
		
		.else
			;Couldn't put an element on the queue
			invoke GetLastError
			.if eax == ERROR_TIMEOUT			
				invoke wsprintf,addr sz, SADD("Sending %d:%d (%s)"), nThreadNum,esi,SADD("timeout") 
			.else
				invoke wsprintf,addr sz, SADD("Sending %d:%d (%s)"), nThreadNum,esi,SADD("full")			
			.endif
		.endif
		
		;Show result of appending element
		invoke SendMessage,hwndLB,LB_ADDSTRING,0,addr sz
		invoke SendMessage,hwndLB,LB_SETCURSEL,eax,0
		invoke Sleep,2500; Wait before appending another element				
		
		inc esi	
	.endw
	
	xor eax,eax
	ret	
ClientThread endp

;***********Server Thread Func***********************************
ServerThread proc uses esi nThreadNum:dword
local hwndLB:dword,	sz[1024]:byte,		e:CQueue_ELEMENT	
	invoke GetDlgItem,g_hwnd, IDC_SERVERS
	mov hwndLB,eax
	
	.while (!g_fShutdown) 		
		;Try to get an element from the queue	
		method g_q,CQueue,Remove,addr e,5000
		.if eax 
			;Indicate which thread is processing it, which thread
      	    ; sent it and which request we're processing	
      	    invoke wsprintf,addr sz, SADD("%d: Processing %d:%d"), nThreadNum, e.m_nThreadNum, e.m_nRequestNum
		
			;The server takes some time to process the request
			mov eax,e.m_nThreadNum
			mov ecx,2000
			mul ecx;2000 * e.m_nThreadNuM
			invoke Sleep,eax
		.else
			;Couldn't get an element from the queue
			invoke wsprintf,addr sz, SADD("%d: (timeout)"), nThreadNum
		.endif
		
		; Show result of processing element
		invoke SendMessage,hwndLB,LB_ADDSTRING,0,addr sz
		invoke SendMessage,hwndLB,LB_SETCURSEL,eax,0
	.endw
	xor eax,eax	
	ret
ServerThread endp
;***********DIALOG MESSAGE PROCEDURE*****************************
DlgProc	proc uses esi edi,hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
local dwThreadID:dword

		mov	eax,uMsg
		.if	eax == WM_CLOSE
			invoke	EndDialog,hWnd,NULL
		.elseif	eax == WM_INITDIALOG			
			chSETDLGICONS hWnd,IDI_QUEUE;Load Dialog Icon			
			
			push hWnd
			pop g_hwnd;Used by client/server threads to show status
			
			xor edi,edi;mov edi,g_nNumThreads
			xor esi,esi
			.while esi < 4;Create the client threads
				invoke CreateThread,NULL, 0,offset ClientThread,esi,0,addr dwThreadID
				mov g_hThreads[edi * 4],eax
				inc esi	
				inc edi
			.endw  
			
			xor esi,esi
			.while esi < 2;Create the server threads
				invoke CreateThread,NULL, 0,offset ServerThread,esi,0,addr dwThreadID
				mov g_hThreads[edi * 4],eax
				inc esi	
				inc edi
			.endw  
			mov g_nNumThreads,edi
			
		.elseif	eax == WM_COMMAND
			mov	eax,wParam
			and eax,0ffffh
			.if	eax == IDCANCEL
				invoke	EndDialog,hWnd,NULL
			.endif
		.else
			mov	eax,FALSE
			ret
		.endif		   
		mov	eax,TRUE
		ret
		
DlgProc	endp
;********************************************************************

end	start
